unit GraphQL.ParamTest;

interface

uses
  Generics.Collections;

type
  TOrder = class
  private
    FID: Integer;
    FOrderDate: String;
    FAmount: Double;
  public
    property ID: Integer       read FID;
    property OrderDate: String read FOrderDate;
    property Amount: Double    read FAmount;
  end;

  TCustomer = class
  private
    FID: Integer;
    FName: String;
    FOrders: TArray<TOrder>;
    function GetOrder(OrderDate: String): TArray<TOrder>;
  public
    property ID: Integer            read FID;
    property Name: String           read FName;
    property Orders: TArray<TOrder> read FOrders;
  end;

  TQuery = class
  public
    function Customer: TCustomer;
  end;

implementation

var
  OrderList: TObjectList<TOrder>;

{ TQuery }

function TQuery.Customer: TCustomer;
var
  LOrder, LOrder2: TOrder;
  LCustomer: TCustomer;
begin
  // this part will be replaced with a database query to read all orders with a specific order date...
  LOrder := TOrder.Create;
  LOrder.FID := 5001;
  LOrder.FOrderDate := '2023-07-20';
  LOrder.FAmount := 190.50;

  LOrder2 := TOrder.Create;
  LOrder2.FID := 5002;
  LOrder2.FOrderDate := '2023-07-20';
  LOrder2.FAmount := 9.95;

  OrderList.Clear;
  OrderList.Add(LOrder);
  OrderList.Add(LOrder2);

  LCustomer := TCustomer.Create;
  LCustomer.FID := 1001;
  LCustomer.FName := 'Jansen International B.V.';
  LCustomer.FOrders := OrderList.ToArray;

  Result := LCustomer;
end;

{ TCustomer }

function TCustomer.GetOrder(OrderDate: String): TArray<TOrder>;
begin
// todo: function for getting specific orders from the database
end;

initialization
  OrderList := TObjectList<TOrder>.Create(True);

finalization
  OrderList.Free;

end.

